//Original:  Pete Thompson (thompp@globalnet.co.uk) 
//Web Site:  http://www.users.globalnet.co.uk/~thompp
//Note: Since cookies have a limit of 20 per site all ToDo's are one string
//Maximum string size is 4K (another cookie limit)
//Todo items are the same as reminders but with date 00
//The first two characters are the item number
//Next 10 characters are DDMMYYYYSS where:
//DD is reminder date, MM month, and YYYY the year 
//SS is the step count, 0 do once then delete, >0 add onto month modulo 12 and save

var exp = new Date(); 
exp.setFullYear(exp.getFullYear() + 10);  //Cookie expire time
var OneDay = 24*60*60*1000;


var Now = new Date();
// Month names for javascript Date.parse() methods.
var months = new Array( "Jan","Feb","Mar", "Apr","May","Jun", "Jul","Aug","Sep","Oct", "Nov", "Dec");
var ToDoList;
var ToDoItem;  //Make these global so can parse as a function
var ItemNo;
var Adate;
var Amnth;
var Ayr;
var Step;
var PreDays;  //warning time for reminders (days)



function SetPreDays(newPD) {
  SetCookie('PreDays', newPD, exp);
  window.location = window.location;
}


function ListReminders() {
  MakeList(1);  // Common function, ==0 is ToDos, <>0 is reminders
}
function ListToDoItems() {
  MakeList(0);  // Common function, ==0 is ToDos, <>0 is reminders
}

function ForceNums() {
  //Force to be numbers
  if (isNaN(Adate)) { 
    Adate = 0;
  }
  if (isNaN(Amnth)) { 
    Amnth = 0;
  }
  if (isNaN(Ayr)) { 
    Ayr = 0;
  }
  if (isNaN(Step)) { 
    Step = 0;
  }
}

function ParseItem() {
  if ((ToDoItem == null) || (ToDoItem == "")) {
    ToDoItem = "000000000000";
  }
  ItemNo = parseInt(ToDoItem.slice(0,2),10); 
  Adate = parseInt(ToDoItem.slice(2,4),10);
  Amnth = parseInt(ToDoItem.slice(4,6),10);
  Ayr = parseInt(ToDoItem.slice(6,10),10);
  Step = parseInt(ToDoItem.slice(10,12),10);
  ForceNums();
  ToDoItem = ToDoItem.slice(12);
}

function BuildItem() {
  var Akey;
  ForceNums();
  Akey = "00"+Step;
  Akey = "0000"+Ayr+Akey.slice(-2);
  Akey = "00"+Amnth+Akey.slice(-6);
  Akey = "00"+Adate+Akey.slice(-8);
  Akey = "00"+ItemNo+Akey.slice(-10);
  ToDoItem = Akey.slice(-12)+ToDoItem+unescape("%13");
}


function MakeList(DoRem) {
  var i;
  var DaysLeft;
  var PreDays = GetCookie('PreDays');
  if (PreDays == 0) {
    PreDays = 7;
    SetCookie('PreDays', PreDays, exp);
  }	
  for (i=0; i < document.PDform.PD.length; i++) {
    if (PreDays == document.PDform.PD[i].value) {
      document.PDform.PD[i].checked = true;
    }  
  }
  i = 1;
  while ((i = NextToDoItem(i)) >0) {
    ParseItem();
    if ((Adate != 0) && (DoRem !=0)) {  //List reminders
      DaysLeft = Math.ceil((Date.parse(Adate+" "+months[Amnth-1]+" "+Ayr)- Now)/OneDay)
      if (DaysLeft <= PreDays) {  //Skip those not soon
        PrintReminder(ToDoItem+" ("+Adate+"/"+Amnth+")", ItemNo, DaysLeft);
      }
    }else{
      if ((Adate == 0) && (DoRem == 0)) {  //List Todos
        PrintItem(ToDoItem, ItemNo);
      }
    }
  }
}

function PrintItem (ToDoItem, Count) {
  document.write("<tr><td width='16'><a class='nu' href='javascript:DeleteItem(",
                Count, ")' target='_self'><img src='tick2a.gif' alt='done!' ",
                "width='13' height='15' border='0' onMouseOver='src=\"tick1a.gif\"\;' ",
                "onMouseOut='src=\"tick2a.gif\"\;' /></a></td>\n");
  document.write("<td>"+ToDoItem+"</td></tr>\n");
}

function PrintReminder (ToDoItem, Count, DaysLeft) {
  document.write("<tr><td width='16'><a class='nu' href='javascript:DeleteItem(",
                Count, ")' target='_self'><img src='tick2a.gif' alt='done!' ",
                "width='13' height='15' border='0' onMouseOver='src=\"tick1a.gif\"\;' ",
                "onMouseOut='src=\"tick2a.gif\"\;' /></a></td>\n");
  if (DaysLeft < 0) {
    document.write("<td><span class='odu'>OVERDUE</span> to "+ToDoItem+"</td></tr>\n");
  }else{ 
    if (DaysLeft == 0) {   
      document.write("<td> <span class='odl'>TODAY</span> to "+ToDoItem+"</td></tr>\n");
    }else{
      document.write("<td><i>"+DaysLeft+" day");
      if (DaysLeft > 1) {
        document.write("s");
      }
      document.write(" to </i>"+ToDoItem+"</td></tr>\n");
    }
  }    
}

function DeleteItem(Count) {
  var Akey;
  var CntS;
  var NewList;
  var i;
  var j;
  ToDoList = GetCookie('ToDo');
  CntS = "00"+Count;
  i = ToDoList.indexOf(unescape("%13")+CntS.slice(-2))+1;
  j = NextToDoItem(i);
  ParseItem();
  if (Step == 0) {
    ToDoList = ToDoList.substring(0,i) + ToDoList.substring(j); 
  }else{
    Ayr = Ayr + Math.floor((Amnth-1+Step)/12);
    Amnth = 1+ ((Amnth-1+Step) % 12)
    BuildItem();
    NewList = ToDoList.substring(0,i)+ ToDoItem + ToDoList.substring(j);
    ToDoList = NewList;
  }
  SetCookie('ToDo', ToDoList, exp);
  window.location = window.location;
}


function getCookieVal (offset) {  
  var endstr = document.cookie.indexOf (";", offset);  
  if (endstr == -1)    
  endstr = document.cookie.length;  
  return unescape(document.cookie.substring(offset, endstr));
}

function GetCookie (name) {  
  var arg = name + "=";  
  var alen = arg.length;  
  var clen = document.cookie.length;  
  var i = 0;  
  while (i < clen) {    
    var j = i + alen;    
    if (document.cookie.substring(i, j) == arg)      
    return getCookieVal(j);    
    i = document.cookie.indexOf(" ", i) + 1;    
    if (i == 0) break;   
  }  
  return null;
}

function SetCookie (name, value) {  
  var argv = SetCookie.arguments;  
  var argc = SetCookie.arguments.length;  
  var expires = (argc > 2) ? argv[2] : null;  
  var path = (argc > 3) ? argv[3] : null;  
  var domain = (argc > 4) ? argv[4] : null;  
  var secure = (argc > 5) ? argv[5] : false;  
  document.cookie = name + "=" + escape (value) + 
  ((expires == null) ? "" : ("; expires=" + expires.toGMTString())) + 
  ((path == null) ? "" : ("; path=" + path)) +  
  ((domain == null) ? "" : ("; domain=" + domain)) +    
  ((secure == true) ? "; secure" : "");
}

function DeleteCookie (name) {  
  var exp = new Date();  
  exp.setTime (exp.getTime() - 1);  
  var cval = GetCookie (name);  
  document.cookie = name + "=" + cval + "; expires=" + exp.toGMTString();
}


function NextToDoItem(i) {
  var j = 0;
  if (i == 1) {
    ToDoList = GetCookie('ToDo');
  }
  if (ToDoList != null) {
    j = ToDoList.indexOf(unescape("%13"), i);
    if (j >0 ) {
      ToDoItem = ToDoList.substring(i,j);
    }
  }else{
    ToDoItem = null;
    j = -1;
  }
  return ++j;
}


//Edit functions
var ShowCnt;
var tabCnt;

function EditItems() {
  var i = 1;
  ShowCnt = 0;
  tabCnt = 3;  //1 and 2 are update and cancel buttons
  while ((i = NextToDoItem(i)) >0) {
    ShowCnt++;
    ParseItem();
    PrintEditItem(ShowCnt);
  }
  Adate = "";	//Add 3 blank entries
  Amnth ="";
  Ayr = "";
  Step = "";
  ToDoItem = "";			
  for (i=1; i <= 3; i++) {
    ShowCnt++;
    PrintEditItem(ShowCnt);
  }
}

function PrintEditItem (Count) { 
  document.write('<tr>',
     '<td><input type="text" size="2" name="Adate', Count, '" value="', Adate, '" tabindex="', tabCnt++,'" /></td>\n',
     '<td><input type="text" size="2" name="Amnth', Count, '" value="', Amnth, '" tabindex="', tabCnt++,'" /></td>\n',
     '<td><input type="text" size="4" name="Ayr', Count, '" value="', Ayr, '" tabindex="', tabCnt++,'" /></td>\n',
     '<td><input type="text" size="2" name="Step', Count, '" value="', Step, '" tabindex="', tabCnt++,'" /></td>\n',
     '<td><input type="text" size="42" name="Item', Count, '" value="', ToDoItem, '" tabindex="', tabCnt++,'" /></td></tr>\n');
}

function UpdateList(form) {
  var i;
  var j = 0;
  ToDoList = unescape("%13");
  for (i=1; i<= ShowCnt; i++) {
    ToDoItem = eval('form.Item'+i+'.value');
    if (!((ToDoItem == "")||(ToDoItem == " ")||(ToDoItem == null))) {
      Adate = parseInt(eval('form.Adate'+i+'.value'));
      Amnth = parseInt(eval('form.Amnth'+i+'.value'));
      Ayr = parseInt(eval('form.Ayr'+i+'.value'));
      Step = parseInt(eval('form.Step'+i+'.value'));
      ItemNo = j++;
      BuildItem();
      ToDoList = ToDoList + ToDoItem;
    }
  }
  SetCookie('ToDo', ToDoList, exp);
  window.location.href = "ToDo.htm";
}

function EditData() {
  document.write('<b>Reminders</b><br />\n');
  document.write('<textarea name="myrem" rows="20" cols="40">',escape(GetCookie('ToDo')),'</textarea>\n');
  document.write('<br /><b>Holidays</b><br />\n');
  document.write('<textarea name="myhol" rows="6" cols="40">',GetCookie('MyHols'),'</textarea>\n');

}

function UpdateData(form) {
  var MyHolList = form.myhol.value;
  ToDoList = unescape(form.myrem.value);
  if (ToDoList.slice(0,1) != unescape("%13")) {
     ToDoList = unescape("%13") + ToDoList;
     alert("Reminder begining format corrected");
  }
  if (ToDoList.slice(-1) != unescape("%13")) {
     ToDoList = ToDoList + unescape("%13");
     alert("Reminder end format corrected");
  }
  if (MyHolList.slice(-1) != ";") {
     MyHolList = MyHolList + ";";
     alert("Holidays end format corrected");
  }
  SetCookie('ToDo', ToDoList, exp);
  SetCookie('MyHols', MyHolList, exp);
  window.location.href = "ToDo.htm";
}





